# Generated by Django 5.0.8 on 2025-01-27 12:23

from django.conf import settings
from django.db import migrations


def create_missing_runs(apps, schema_editor):
    """
    List all (corpus_id, worker_version_id) sets for all tables containing ML
    results where the worker_version_id is set but there is no worker_run_id.
    Create Workers processes on each corpus and worker runs for each version.
    """
    from arkindex.documents.migrations.utils.worker_run import create_missing_worker_runs
    # Add a line break for visibility
    print()
    create_missing_worker_runs(get_model=apps.get_model)


class Migration(migrations.Migration):
    atomic = False

    dependencies = [
        ("documents", "0015_nulls_not_distinct"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.RunPython(
            create_missing_runs,
            reverse_code=migrations.RunPython.noop,
        ),
   ]
