# Generated by Django 4.1.7 on 2023-05-29 11:49

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models
from enumfields import Enum, fields

import arkindex.process.models
import pgtrigger.compiler
import pgtrigger.migrations


class TmpProcessMode(Enum):
    Repository = "repository"
    Local = "local"


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("training", "0001_initial"),
        ("ponos", "0001_initial"),
        ("users", "0001_initial"),
        ("process", "0002_initial"),
        ("documents", "0003_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.AddField(
            model_name="repository",
            name="credentials",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="repos", to="users.oauthcredentials"),
        ),
        migrations.AddField(
            model_name="repository",
            name="git_ref_revisions",
            field=models.ManyToManyField(through="process.GitRef", to="process.revision"),
        ),
        migrations.AddField(
            model_name="processelement",
            name="element",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="process_elements", to="documents.element"),
        ),
        migrations.AddField(
            model_name="processelement",
            name="process",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="process_elements", to="process.process"),
        ),
        migrations.AddField(
            model_name="process",
            name="corpus",
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name="processes", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="process",
            name="creator",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="processes", to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name="process",
            name="element",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to="documents.element"),
        ),
        migrations.AddField(
            model_name="process",
            name="element_type",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="element_imports", to="documents.elementtype"),
        ),
        migrations.AddField(
            model_name="process",
            name="elements",
            field=models.ManyToManyField(related_name="processes", through="process.ProcessElement", to="documents.element"),
        ),
        migrations.AddField(
            model_name="process",
            name="files",
            field=models.ManyToManyField(related_name="processes", to="process.datafile"),
        ),
        migrations.AddField(
            model_name="process",
            name="folder_type",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="folder_imports", to="documents.elementtype"),
        ),
        migrations.AddField(
            model_name="process",
            name="model",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name="training_processes", to="training.model"),
        ),
        migrations.AddField(
            model_name="process",
            name="revision",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name="processes", to="process.revision"),
        ),
        migrations.AddField(
            model_name="process",
            name="template",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="applications", to="process.process"),
        ),
        migrations.AddField(
            model_name="process",
            name="test_folder",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="test_folder_processes", to="documents.element"),
        ),
        migrations.AddField(
            model_name="process",
            name="train_folder",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="train_folder_processes", to="documents.element"),
        ),
        migrations.AddField(
            model_name="process",
            name="validation_folder",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="validation_folder_processes", to="documents.element"),
        ),
        migrations.AddField(
            model_name="process",
            name="versions",
            field=models.ManyToManyField(related_name="processes", through="process.WorkerRun", to="process.workerversion"),
        ),
        migrations.AddField(
            model_name="process",
            name="workflow",
            field=models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to="ponos.workflow"),
        ),
        migrations.AddField(
            model_name="gitref",
            name="repository",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="refs", to="process.repository"),
        ),
        migrations.AddField(
            model_name="gitref",
            name="revision",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="refs", to="process.revision"),
        ),
        migrations.AddField(
            model_name="datafile",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="files", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="corpusworkerversion",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="worker_version_cache", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="corpusworkerversion",
            name="worker_version",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="corpus_cache", to="process.workerversion"),
        ),
        migrations.AddConstraint(
            model_name="workerversion",
            constraint=models.CheckConstraint(condition=models.Q(("docker_image_id", None), ("state", arkindex.process.models.WorkerVersionState["Available"]), _negated=True), name="workerversion_available_requires_docker_image"),
        ),
        migrations.AlterUniqueTogether(
            name="workerversion",
            unique_together={("worker", "revision")},
        ),
        migrations.AlterUniqueTogether(
            name="workerrun",
            unique_together={("version", "process")},
        ),
        migrations.AddConstraint(
            model_name="workerconfiguration",
            constraint=models.CheckConstraint(condition=models.Q(("configuration__typeof", "object")), name="worker_configuration_configuration_objects"),
        ),
        migrations.AlterUniqueTogether(
            name="workerconfiguration",
            unique_together={("worker", "name"), ("worker", "configuration_hash")},
        ),
        migrations.AddConstraint(
            model_name="workeractivity",
            constraint=models.UniqueConstraint(condition=models.Q(("configuration__isnull", True)), fields=("worker_version", "element"), name="worker_activity_unique_no_configuration"),
        ),
        migrations.AddConstraint(
            model_name="workeractivity",
            constraint=models.UniqueConstraint(condition=models.Q(("configuration__isnull", False)), fields=("worker_version", "element", "configuration"), name="worker_activity_unique_configuration"),
        ),
        migrations.AddConstraint(
            model_name="workeractivity",
            constraint=models.CheckConstraint(condition=models.Q(models.Q(("state", arkindex.process.models.WorkerActivityState["Started"]), _negated=True), ("started__isnull", False), _connector="OR"), name="worker_activity_started_requires_started"),
        ),
        migrations.AlterUniqueTogether(
            name="worker",
            unique_together={("slug", "repository")},
        ),
        migrations.AlterUniqueTogether(
            name="revision",
            unique_together={("repo", "hash")},
        ),
        migrations.AlterUniqueTogether(
            name="processelement",
            unique_together={("process", "element")},
        ),
        migrations.AddConstraint(
            model_name="process",
            constraint=models.UniqueConstraint(models.F("creator"), condition=models.Q(("mode", arkindex.process.models.ProcessMode["Local"])), name="unique_local_process", violation_error_message="Only one local process is allowed per user."),
        ),
        migrations.AddConstraint(
            model_name="process",
            constraint=models.CheckConstraint(condition=models.Q(models.Q(("mode", arkindex.process.models.ProcessMode["Local"]), _negated=True), ("workflow", None), _connector="OR"), name="local_process_no_workflow", violation_error_message="Local processes cannot be started."),
        ),
        migrations.AlterField(
            model_name="process",
            name="mode",
            field=fields.EnumField(enum=TmpProcessMode, max_length=30)
        ),
        migrations.AddConstraint(
            model_name="process",
            constraint=models.CheckConstraint(condition=models.Q(("mode__in", (TmpProcessMode["Local"], TmpProcessMode["Repository"])), models.Q(("corpus", None), _negated=True), _connector="XOR"), name="check_process_corpus", violation_error_message="Local and repository processes cannot have a corpus, and other modes must have one set."),
        ),
        migrations.AlterField(
            model_name="process",
            name="mode",
            field=fields.EnumField(enum=arkindex.process.models.ProcessMode, max_length=30)
        ),
        migrations.AlterUniqueTogether(
            name="gitref",
            unique_together={("name", "repository")},
        ),
        migrations.AlterUniqueTogether(
            name="corpusworkerversion",
            unique_together={("corpus", "worker_version")},
        ),
        pgtrigger.migrations.AddTrigger(
            model_name="workeractivity",
            trigger=pgtrigger.compiler.Trigger(name="update_workeractivity_updated", sql=pgtrigger.compiler.UpsertTriggerSql(func="NEW.updated = now(); RETURN NEW;", hash="1e5a8fa0718f420e6cd4f2a31434cd39a9c9bc67", operation="UPDATE", pgid="pgtrigger_update_workeractivity_updated_f2812", table="process_workeractivity", when="BEFORE")),
        ),
        pgtrigger.migrations.AddTrigger(
            model_name="workeractivity",
            trigger=pgtrigger.compiler.Trigger(name="read_only_workeractivity_updated", sql=pgtrigger.compiler.UpsertTriggerSql(condition='WHEN (OLD."updated" IS DISTINCT FROM (NEW."updated"))', func="RAISE EXCEPTION 'pgtrigger: Cannot update rows from % table', TG_TABLE_NAME;", hash="6276c6971a1d2669659e407418e2db1fa7dc6965", operation="UPDATE", pgid="pgtrigger_read_only_workeractivity_updated_a80ab", table="process_workeractivity", when="BEFORE")),
        ),
    ]
