# Generated by Django 5.0.8 on 2024-08-20 18:02

from django.db import migrations, models
from enumfields import EnumField

from arkindex.process.models import ArkindexFeature, WorkerVersionState


class Migration(migrations.Migration):

    dependencies = [
        ("documents", "0012_alter_transcriptionentity_id"),
        ("process", "0041_drop_old_git_references"),
    ]

    operations = [
        migrations.AddField(
            model_name="workerversion",
            name="feature",
            field=EnumField(
                blank=True,
                enum=ArkindexFeature,
                help_text="An Arkindex feature that this worker version provides. There can only be one worker version per feature across an Arkindex instance.",
                max_length=20,
                null=True,
            ),
        ),
        migrations.AddConstraint(
            model_name="workerversion",
            constraint=models.UniqueConstraint(
                condition=models.Q(feature__isnull=False),
                fields=("feature",),
                name="workerversion_unique_feature",
                violation_error_message="There can only be one worker version per feature across an Arkindex instance.",
            ),
        ),
        migrations.AddConstraint(
            model_name="workerversion",
            constraint=models.CheckConstraint(
                condition=models.Q(state=WorkerVersionState.Available) | models.Q(feature=None),
                name="workerversion_feature_requires_available",
                violation_error_message="A worker version can only provide an Arkindex feature if it is marked as available.",
            ),
        ),
    ]
