select min(length),
       max(length)
FROM
    (select array_length(p.path, 1) as length
     from documents_elementpath as p
     inner join
         (SELECT "documents_element"."id"
          FROM "documents_element"
          WHERE ("documents_element"."corpus_id" = '{corpus_id}'::uuid
                 AND NOT ("documents_element"."worker_version_id" IS NULL))) as input on (array[input.id] && p.path)) as lengths ;

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT W0."id"
         FROM "documents_transcriptionentity" W0
         INNER JOIN "documents_transcription" W1 ON (W0."transcription_id" = W1."id")
         WHERE W1."element_id" IN
                 (SELECT V0."id"
                  FROM "documents_element" V0
                  INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
                  WHERE (V1."path")[2] IN
                          (SELECT U0."id"
                           FROM "documents_element" U0
                           WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                                  AND NOT (U0."worker_version_id" IS NULL)))));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE (V1."path")[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE (V1."path")[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE (V1."path")[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE (V1."path")[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE (V1."path")[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

DELETE
FROM "process_processelement"
WHERE "process_processelement"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE (V1."path")[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

UPDATE "process_process"
SET "element_id" = NULL
WHERE "process_process"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE (V1."path")[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
              WHERE ("documents_elementpath"."path")[2] IN
                      (SELECT U0."id"
                       FROM "documents_element" U0
                       WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                              AND NOT (U0."worker_version_id" IS NULL)))) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
WHERE ("documents_elementpath"."path")[2] IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT V0."id"
         FROM "documents_transcriptionentity" V0
         INNER JOIN "documents_transcription" V1 ON (V0."transcription_id" = V1."id")
         WHERE V1."element_id" IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL))));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "process_processelement"
WHERE "process_processelement"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

UPDATE "process_process"
SET "element_id" = NULL
WHERE "process_process"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              WHERE ("documents_element"."corpus_id" = '{corpus_id}'::uuid
                     AND NOT ("documents_element"."worker_version_id" IS NULL))) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
WHERE ("documents_element"."corpus_id" = '{corpus_id}'::uuid
       AND NOT ("documents_element"."worker_version_id" IS NULL));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."id" IN
        (SELECT U0."id"
         FROM "documents_classification" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT U0."id"
         FROM "documents_transcriptionentity" U0
         INNER JOIN "documents_transcription" U1 ON (U0."transcription_id" = U1."id")
         INNER JOIN "documents_element" U2 ON (U1."element_id" = U2."id")
         WHERE (U2."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U1."worker_version_id" IS NULL)));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT U0."id"
         FROM "documents_transcriptionentity" U0
         INNER JOIN "documents_entity" U1 ON (U0."entity_id" = U1."id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."id" IN
        (SELECT U0."id"
         FROM "documents_transcription" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."id" IN
        (SELECT U0."id"
         FROM "documents_metadata" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

UPDATE "documents_metadata"
SET "entity_id" = NULL
WHERE "documents_metadata"."entity_id" IN
        (SELECT U0."id"
         FROM "documents_entity" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."entity_id" IN
        (SELECT U0."id"
         FROM "documents_entity" U0
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)));

DELETE
FROM "documents_entity"
WHERE ("documents_entity"."corpus_id" = '{corpus_id}'::uuid
       AND NOT ("documents_entity"."worker_version_id" IS NULL));

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."id" IN
        (SELECT U0."id"
         FROM "process_workeractivity" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         WHERE U1."corpus_id" = '{corpus_id}'::uuid)
