SELECT 1 AS "a"
FROM "documents_elementpath"
WHERE "documents_elementpath"."path" && (ARRAY['{element_id}'::uuid])::uuid[]
LIMIT 1;

select min(length),
       max(length)
FROM
    (select array_length(p.path, 1) as length
     from documents_elementpath as p
     inner join
         (SELECT "documents_element"."id"
          FROM "documents_element"
          INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
          INNER JOIN "process_workerrun" ON ("documents_element"."worker_run_id" = "process_workerrun"."id")
          WHERE ("documents_elementpath"."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                 AND NOT ("documents_element"."worker_version_id" IS NULL)
                 AND "process_workerrun"."model_version_id" = '{model_version_id}'::uuid)) as input on (array[input.id] && p.path)) as lengths ;

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT V0."id"
         FROM "documents_transcriptionentity" V0
         INNER JOIN "documents_transcription" V1 ON (V0."transcription_id" = V1."id")
         WHERE V1."element_id" IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
                  INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
                  WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                         AND NOT (U0."worker_version_id" IS NULL)
                         AND U3."model_version_id" = '{model_version_id}'::uuid)));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "process_processelement"
WHERE "process_processelement"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

UPDATE "process_process"
SET "element_id" = NULL
WHERE "process_process"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U1."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
              INNER JOIN "process_workerrun" ON ("documents_element"."worker_run_id" = "process_workerrun"."id")
              WHERE ("documents_elementpath"."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                     AND NOT ("documents_element"."worker_version_id" IS NULL)
                     AND "process_workerrun"."model_version_id" = '{model_version_id}'::uuid)) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
INNER JOIN "process_workerrun" ON ("documents_element"."worker_run_id" = "process_workerrun"."id")
WHERE ("documents_elementpath"."path" && (ARRAY['{element_id}'::uuid])::uuid[]
       AND NOT ("documents_element"."worker_version_id" IS NULL)
       AND "process_workerrun"."model_version_id" = '{model_version_id}'::uuid);

DELETE
FROM "documents_classification"
WHERE "documents_classification"."id" IN
        (SELECT U0."id"
         FROM "documents_classification" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         INNER JOIN "documents_elementpath" U2 ON (U1."id" = U2."element_id")
         INNER JOIN "process_workerrun" U4 ON (U0."worker_run_id" = U4."id")
         WHERE (U2."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U4."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT U0."id"
         FROM "documents_transcriptionentity" U0
         INNER JOIN "documents_transcription" U1 ON (U0."transcription_id" = U1."id")
         INNER JOIN "documents_element" U2 ON (U1."element_id" = U2."id")
         INNER JOIN "documents_elementpath" U3 ON (U2."id" = U3."element_id")
         INNER JOIN "process_workerrun" U5 ON (U1."worker_run_id" = U5."id")
         WHERE (U3."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U1."worker_version_id" IS NULL)
                AND U5."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."id" IN
        (SELECT U0."id"
         FROM "documents_transcription" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         INNER JOIN "documents_elementpath" U2 ON (U1."id" = U2."element_id")
         INNER JOIN "process_workerrun" U4 ON (U0."worker_run_id" = U4."id")
         WHERE (U2."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U4."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."id" IN
        (SELECT U0."id"
         FROM "documents_metadata" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         INNER JOIN "documents_elementpath" U2 ON (U1."id" = U2."element_id")
         INNER JOIN "process_workerrun" U4 ON (U0."worker_run_id" = U4."id")
         WHERE (U2."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND NOT (U0."worker_version_id" IS NULL)
                AND U4."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."id" IN
        (SELECT U0."id"
         FROM "process_workeractivity" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         INNER JOIN "documents_elementpath" U2 ON (U1."id" = U2."element_id")
         WHERE (U2."path" && (ARRAY['{element_id}'::uuid])::uuid[]
                AND U0."model_version_id" = '{model_version_id}'::uuid));

select min(length),
       max(length)
FROM
    (select array_length(p.path, 1) as length
     from documents_elementpath as p
     inner join
         (SELECT "documents_element"."id"
          FROM "documents_element"
          INNER JOIN "process_workerrun" ON ("documents_element"."worker_run_id" = "process_workerrun"."id")
          WHERE ("documents_element"."id" = '{element_id}'::uuid
                 AND NOT ("documents_element"."worker_version_id" IS NULL)
                 AND "process_workerrun"."model_version_id" = '{model_version_id}'::uuid)) as input on (array[input.id] && p.path)) as lengths ;

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT V0."id"
         FROM "documents_transcriptionentity" V0
         INNER JOIN "documents_transcription" V1 ON (V0."transcription_id" = V1."id")
         WHERE V1."element_id" IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
                  WHERE (U0."id" = '{element_id}'::uuid
                         AND NOT (U0."worker_version_id" IS NULL)
                         AND U2."model_version_id" = '{model_version_id}'::uuid)));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
         WHERE (U0."id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U2."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "process_workeractivity"
WHERE "process_workeractivity"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
         WHERE (U0."id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U2."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
         WHERE (U0."id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U2."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
         WHERE (U0."id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U2."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
         WHERE (U0."id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U2."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "process_processelement"
WHERE "process_processelement"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
         WHERE (U0."id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U2."model_version_id" = '{model_version_id}'::uuid));

UPDATE "process_process"
SET "element_id" = NULL
WHERE "process_process"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         INNER JOIN "process_workerrun" U2 ON (U0."worker_run_id" = U2."id")
         WHERE (U0."id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U2."model_version_id" = '{model_version_id}'::uuid));

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              INNER JOIN "process_workerrun" ON ("documents_element"."worker_run_id" = "process_workerrun"."id")
              WHERE ("documents_element"."id" = '{element_id}'::uuid
                     AND NOT ("documents_element"."worker_version_id" IS NULL)
                     AND "process_workerrun"."model_version_id" = '{model_version_id}'::uuid)) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
INNER JOIN "process_workerrun" ON ("documents_element"."worker_run_id" = "process_workerrun"."id")
WHERE ("documents_element"."id" = '{element_id}'::uuid
       AND NOT ("documents_element"."worker_version_id" IS NULL)
       AND "process_workerrun"."model_version_id" = '{model_version_id}'::uuid);

DELETE
FROM "documents_classification"
WHERE "documents_classification"."id" IN
        (SELECT U0."id"
         FROM "documents_classification" U0
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U0."element_id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT U0."id"
         FROM "documents_transcriptionentity" U0
         INNER JOIN "documents_transcription" U1 ON (U0."transcription_id" = U1."id")
         INNER JOIN "process_workerrun" U4 ON (U1."worker_run_id" = U4."id")
         WHERE (U1."element_id" = '{element_id}'::uuid
                AND NOT (U1."worker_version_id" IS NULL)
                AND U4."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."id" IN
        (SELECT U0."id"
         FROM "documents_transcription" U0
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U0."element_id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."id" IN
        (SELECT U0."id"
         FROM "documents_metadata" U0
         INNER JOIN "process_workerrun" U3 ON (U0."worker_run_id" = U3."id")
         WHERE (U0."element_id" = '{element_id}'::uuid
                AND NOT (U0."worker_version_id" IS NULL)
                AND U3."model_version_id" = '{model_version_id}'::uuid));

DELETE
FROM "process_workeractivity"
WHERE ("process_workeractivity"."element_id" = '{element_id}'::uuid
       AND "process_workeractivity"."model_version_id" = '{model_version_id}'::uuid)
